
#include <SPI.h>             
#include <Ethernet.h>        
#include <IEEE1888FetchClient.h>  
#include <Time.h>           

const unsigned int MEASURE_INTERVAL = 60;  // 间隔时间
char timezone[] = "+08:00";          
const long timezoneOffset = +28800L; 

static byte local_mac[6] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; 
static byte local_ip4[4]     = { 10, 1, 1, 188 }; // 本地IP
static byte local_gateway[4] = { 10, 1, 1, 1 };  // 网关
static byte local_netmask[4] = { 255, 255, 255, 0 }; // 子网掩码


static byte server_ip4[4]  = { 10, 1, 1, 130 };  // 服务端地址
static char server_host[] = "10.1.1.130"; //服务端主机名
static char server_path[] = "/IEEE1888Storage";    //存储路径
static int server_port = 1888;

IEEE1888FetchClient IEEE1888;

fetch_point element[]=
{
  {"http://biigroup.cn/2508/Humidity", 0,"",""},
  {"http://biigroup.cn/2508/Humidity", 1,"",""},
  {"http://biigroup.cn/2501/Illumination",2,"2013-10-10T13:30:00+08:00","2013-10-20T13:33:00+08:00"},
};

int s = 0;
void setup()
{
  int i;

  // I/O初始化
  Serial.begin(9600);

  Serial.print("IP = "); Serial.println(ip_to_str(local_ip4));
  Serial.print("NM = "); Serial.println(ip_to_str(local_netmask));
  Serial.print("GW = "); Serial.println(ip_to_str(local_gateway));
  Ethernet.begin(local_mac, local_ip4, local_gateway, local_netmask);
  
  IEEE1888.begin(server_ip4, server_host, server_path, server_port, &deal_with_result);
}

void loop()
{
  Serial.println("IEEE1888 downloading... ");
  int ret = IEEE1888.get(element,3);
  delay(MEASURE_INTERVAL * 100UL);  
}

char *ip_to_str(byte *ip)
{
  static char str[16];
  sprintf(str, "%d.%d.%d.%d\0", ip[0], ip[1], ip[2], ip[3]);
  return(str);
}

int deal_with_result(ieee1888_value* ieee1888value){

	while(ieee1888value){
		Serial.print("pointid: ");
		Serial.println(ieee1888value->pointid);
		Serial.print("time: ");
		Serial.println(ieee1888value->time);
		Serial.print("content: ");
		Serial.println(ieee1888value->content);
		ieee1888value = ieee1888value->next;
	}
	Serial.println("deal fetch data over!!!");

	return 0;
}
