// --------- IEEE1888WriteClient.h (begin) ---------
#ifndef __IEEE1888WriteClient__
#define __IEEE1888WriteClient__

#define IEEE1888_UPLOAD_OK       0  
#define IEEE1888_UPLOAD_CONNFAIL 1  
#define IEEE1888_UPLOAD_DNSERR   2  
#define IEEE1888_UPLOAD_HTTPERR  3  
#define IEEE1888_UPLOAD_IEEE1888ERR 4
#define IEEE1888_UPLOAD_FATAL   99  

#define MAX_IEEE1888_POINTID_LEN 64      //pointID最大长度

struct ieee1888_element {
  char cid[MAX_IEEE1888_POINTID_LEN];
  char* value;          
  unsigned short year;        
  byte month;        
  byte day;           
  byte hour;          
  byte minute;       
  byte second;        
  char* timezone;       
};


class IEEE1888WriteClient {
public: 
  void begin(
             const char* server_host,
             const char* server_path,
             unsigned short server_port
			 );
  int post(struct ieee1888_element* v, byte esize);
  
private:
  char *element_time_to_str(struct ieee1888_element* e);
  
private: 
  const char* server_host;
  const char* server_path;
  unsigned short server_port;
  const char* ieee1888_id_prefix;
};

#endif  
// --------- IEEE1888WriteClient.h (end) ---------
